// ignore_for_file: omit_local_variable_types

part of pdfio;

class PImage extends XObject {

  String get name => '/Im$idr';

  PImage(
    PDocument document, {
    this.width,
    this.height,
    @required Uint8List image,
  }) : super(document, '/Image', isBinary: true) {
    params['/Width'] = PNum(width);
    params['/Height'] = PNum(height);
    params['/BitsPerComponent'] = const PNum(8);
    params['/Name'] = PName(name);
    params['/ColorSpace'] = const PName('/DeviceRGB');
    stream.putBytes(image);
  }

  static PImage fromImage(PDocument document, {@required im.Image image}) {
    return PImage(
      document,
      image: image.getBytes(format: im.Format.rgb),
      width: image.width,
      height: image.height,
    );
  }

  final int width;
  final int height;

}
